%define anolis_release 1

%bcond_with system_lapack
%global lapackver 3.11.0

Name:           openblas
Summary:        An optimized BLAS library based on GotoBLAS2
Version:        0.3.26
Release:        %{anolis_release}%{?dist}
License:        BSD-3-Clause
URL:            https://github.com/OpenMathLib/OpenBLAS
Source0:        https://github.com/OpenMathLib/OpenBLAS/releases/download/v%{version}/OpenBLAS-%{version}.tar.gz
Patch0001:      0001-openblas-0.2.15-system_lapack.patch
Patch0002:      0002-openblas-0.2.5-libname.patch
Patch0003:      0003-openblas-0.3.11-tests.patch

BuildRequires:  make gcc gcc-c++ gcc-gfortran
BuildRequires:  perl-devel
Obsoletes:      %{name}-Rblas < %{EVR}

%global execstack 1
%if %{execstack}
BuildRequires:  execstack
%endif

%if %{with system_lapack}
BuildRequires:  lapack-static
%global lapacke 1

%else
%global lapacke 1
Provides:       bundled(lapack) = %{lapackver}
%endif

%global build64 1
%bcond_without cpp_thread_check

%if %{with system_lapack}
%if %build64
BuildRequires:  lapack64-static
%endif
%endif

%description
OpenBLAS is an optimized BLAS (Basic Linear Algebra Subprograms) library based on GotoBLAS2 1.13 BSD version.

For a general introduction to the BLAS routines, please refer to the extensive documentation of
their reference implementation hosted at netlib: https://www.netlib.org/blas. On that site you will
likewise find documentation for the reference implementation of the higher-level library LAPACK -
the Linear Algebra Package that comes included with OpenBLAS. If you are looking for a general primer
or refresher on Linear Algebra, the set of six 20-minute lecture videos by Prof. Gilbert Strang on either
MIT OpenCourseWare https://ocw.mit.edu/resources/res-18-010-a-2020-vision-of-linear-algebra-spring-2020/ or
Youtube https://www.youtube.com/playlist?list=PLUl4u3cNGP61iQEFiWLE21EJCxwmWvvek may be helpful.

%package serial
Summary:        An optimized BLAS library based on GotoBLAS2, serial version
Requires:       %{name} = %{EVR}

%description serial
OpenBLAS is an optimized BLAS library based on GotoBLAS2 1.13 BSD \
version. The project is supported by the Lab of Parallel Software and \
Computational Science, ISCAS. http://www.rdcps.ac.cn

This package contains the sequential library compiled with a 32-bit
integer interface.

%package openmp
Summary:        An optimized BLAS library based on GotoBLAS2, OpenMP version
Requires:       %{name} = %{EVR}

%description openmp
OpenBLAS is an optimized BLAS library based on GotoBLAS2 1.13 BSD \
version. The project is supported by the Lab of Parallel Software and \
Computational Science, ISCAS. http://www.rdcps.ac.cn

This package contains the library compiled with OpenMP support with
32-bit integer interface.

%package threads
Summary:        An optimized BLAS library based on GotoBLAS2, pthreads version
Requires:       %{name} = %{EVR}

%description threads
OpenBLAS is an optimized BLAS library based on GotoBLAS2 1.13 BSD \
version. The project is supported by the Lab of Parallel Software and \
Computational Science, ISCAS. http://www.rdcps.ac.cn

This package contains the library compiled with threading support and
a 32-bit integer interface.

%if %build64
%package serial64
Summary:        An optimized BLAS library based on GotoBLAS2, serial version
Requires:       %{name} = %{EVR}

%description serial64
OpenBLAS is an optimized BLAS library based on GotoBLAS2 1.13 BSD \
version. The project is supported by the Lab of Parallel Software and \
Computational Science, ISCAS. http://www.rdcps.ac.cn

This package contains the sequential library compiled with a 64-bit
integer interface.

%package openmp64
Summary:        An optimized BLAS library based on GotoBLAS2, OpenMP version
Requires:       %{name} = %{EVR}

%description openmp64
OpenBLAS is an optimized BLAS library based on GotoBLAS2 1.13 BSD \
version. The project is supported by the Lab of Parallel Software and \
Computational Science, ISCAS. http://www.rdcps.ac.cn

This package contains the library compiled with OpenMP support and
64-bit integer interface.

%package threads64
Summary:        An optimized BLAS library based on GotoBLAS2, pthreads version
Requires:       %{name} = %{EVR}

%description threads64
OpenBLAS is an optimized BLAS library based on GotoBLAS2 1.13 BSD \
version. The project is supported by the Lab of Parallel Software and \
Computational Science, ISCAS. http://www.rdcps.ac.cn

This package contains the library compiled with threading support and
64-bit integer interface.

%package serial64_
Summary:        An optimized BLAS library based on GotoBLAS2, serial version
Requires:       %{name} = %{EVR}

%description serial64_
OpenBLAS is an optimized BLAS library based on GotoBLAS2 1.13 BSD \
version. The project is supported by the Lab of Parallel Software and \
Computational Science, ISCAS. http://www.rdcps.ac.cn

This package contains the sequential library compiled with a 64-bit
integer interface and a symbol name suffix.

%package openmp64_
Summary:        An optimized BLAS library based on GotoBLAS2, OpenMP version
Requires:       %{name} = %{EVR}

%description openmp64_
OpenBLAS is an optimized BLAS library based on GotoBLAS2 1.13 BSD \
version. The project is supported by the Lab of Parallel Software and \
Computational Science, ISCAS. http://www.rdcps.ac.cn

This package contains the library compiled with OpenMP support and
64-bit integer interface and a symbol name suffix.

%package threads64_
Summary:        An optimized BLAS library based on GotoBLAS2, pthreads version
Requires:       %{name} = %{EVR}

%description threads64_
OpenBLAS is an optimized BLAS library based on GotoBLAS2 1.13 BSD \
version. The project is supported by the Lab of Parallel Software and \
Computational Science, ISCAS. http://www.rdcps.ac.cn

This package contains the library compiled with threading support and
64-bit integer interface and a symbol name suffix.
%endif

%package devel
Summary:        Development headers and libraries for OpenBLAS
Requires:       %{name} = %{EVR}
Requires:       %{name}-serial = %{EVR}
Requires:       %{name}-openmp = %{EVR}
Requires:       %{name}-threads = %{EVR}
%if %build64
Requires:       %{name}-serial64 = %{EVR}
Requires:       %{name}-serial64_ = %{EVR}
Requires:       %{name}-openmp64 = %{EVR}
Requires:       %{name}-threads64 = %{EVR}
Requires:       %{name}-openmp64_ = %{EVR}
Requires:       %{name}-threads64_ = %{EVR}
%endif
Requires:       %{name}-srpm-macros

%description devel
OpenBLAS is an optimized BLAS library based on GotoBLAS2 1.13 BSD \
version. The project is supported by the Lab of Parallel Software and \
Computational Science, ISCAS. http://www.rdcps.ac.cn

This package contains the development headers and libraries.

%package static
Summary:        Static version of OpenBLAS
Requires:       %{name}-devel = %{EVR}

%description static
OpenBLAS is an optimized BLAS library based on GotoBLAS2 1.13 BSD \
version. The project is supported by the Lab of Parallel Software and \
Computational Science, ISCAS. http://www.rdcps.ac.cn

This package contains the static libraries.

%prep
%setup -q -c -T

tar zxf %{SOURCE0}
cd OpenBLAS-%{version}
%if %{with system_lapack}
%patch -P0001 -p1 -b .system_lapack
%endif
%patch -P0002 -p1 -b .libname
%patch -P0003 -p1 -b .tests

find -name \*.f -exec chmod 644 {} \;

%if %{with system_lapack}
rm -rf lapack-netlib
%endif

cd ..
cp -ar OpenBLAS-%{version} openmp
cp -ar OpenBLAS-%{version} threaded

%if %build64
for d in {serial,threaded,openmp}64{,_}; do
    cp -ar OpenBLAS-%{version} $d
done
%endif

mv OpenBLAS-%{version} serial

%if %{with system_lapack}
mkdir netliblapack
cd netliblapack
ar x %{_libdir}/liblapack_pic.a
for f in laswp getf2 getrf potf2 potrf lauu2 lauum trti2 trtri getrs; do
    \rm {c,d,s,z}$f.o
done

%if %{lapacke}
ar x %{_libdir}/liblapacke.a
%endif

echo "TOPDIR = .." > Makefile
echo "include ../Makefile.system" >> Makefile
echo "COMMONOBJS = \\" >> Makefile
for i in *.o; do
 echo "$i \\" >> Makefile
done
echo -e "\n\ninclude \$(TOPDIR)/Makefile.tail" >> Makefile

%if %{lapacke}
# Copy include files
cp -a %{_includedir}/lapacke .
%endif
cd ..

for d in serial threaded openmp; do
    cp -pr netliblapack $d
done
rm -rf netliblapack

%if %build64
mkdir netliblapack64
cd netliblapack64
ar x %{_libdir}/liblapack64_pic.a
for f in laswp getf2 getrf potf2 potrf lauu2 lauum trti2 trtri getrs; do
    \rm {c,d,s,z}$f.o
done

%if %{lapacke}
ar x %{_libdir}/liblapacke.a
%endif

echo "TOPDIR = .." > Makefile
echo "include ../Makefile.system" >> Makefile
echo "COMMONOBJS = \\" >> Makefile
for i in *.o; do
    echo "$i \\" >> Makefile
done
echo -e "\n\ninclude \$(TOPDIR)/Makefile.tail" >> Makefile

%if %{lapacke}
# Copy include files
cp -a %{_includedir}/lapacke .
%endif

cd ..

for d in {serial,threaded,openmp}64{,_}; do
    cp -pr netliblapack64 $d/netliblapack
done
rm -rf netliblapack64
%endif
%endif

%build
%define _lto_cflags %{nil}
%if !%{lapacke}
LAPACKE="NO_LAPACKE=1"
%endif

NMAX="NUM_THREADS=128"

%ifarch x86_64
TARGET="TARGET=CORE2 DYNAMIC_ARCH=1 DYNAMIC_OLDER=1"
%endif
%ifarch aarch64
TARGET="TARGET=ARMV8 DYNAMIC_ARCH=1 DYNAMIC_OLDER=1"
%endif
%ifarch loongarch64
TARGET="TARGET=LOONGSONGENERIC DYNAMIC_ARCH=1"
%endif

COMMON="%{optflags} -fPIC"
FCOMMON="%{optflags} -fPIC -frecursive"
export LDFLAGS="%{__global_ldflags}"

COMMON="%{optflags} -fPIC"
FCOMMON="$COMMON -frecursive"
make -C serial     $TARGET USE_THREAD=0 USE_LOCKING=1 USE_OPENMP=0 FC=gfortran CC=gcc COMMON_OPT="$COMMON" FCOMMON_OPT="$FCOMMON" $NMAX LIBPREFIX="libopenblas"      $AVX $LAPACKE INTERFACE64=0
make -C threaded   $TARGET USE_THREAD=1 USE_OPENMP=0 FC=gfortran CC=gcc COMMON_OPT="$COMMON" FCOMMON_OPT="$FCOMMON" $NMAX LIBPREFIX="libopenblasp"     $AVX $LAPACKE INTERFACE64=0

COMMON="%{optflags} -fPIC -fopenmp -pthread"
FCOMMON="$COMMON -frecursive"
make -C openmp     $TARGET USE_THREAD=1 USE_OPENMP=1 FC=gfortran CC=gcc COMMON_OPT="$COMMON" FCOMMON_OPT="$FCOMMON" $NMAX LIBPREFIX="libopenblaso"     $AVX $LAPACKE INTERFACE64=0 %{with cpp_thread_check:CPP_THREAD_SAFETY_TEST=1}

%if %build64
COMMON="%{optflags} -fPIC"
FCOMMON="$COMMON -frecursive -fdefault-integer-8"
make -C serial64   $TARGET USE_THREAD=0 USE_LOCKING=1 USE_OPENMP=0 FC=gfortran CC=gcc COMMON_OPT="$COMMON" FCOMMON_OPT="$FCOMMON" $NMAX LIBPREFIX="libopenblas64"    $AVX $LAPACKE INTERFACE64=1
make -C threaded64 $TARGET USE_THREAD=1 USE_OPENMP=0 FC=gfortran CC=gcc COMMON_OPT="$COMMON" FCOMMON_OPT="$FCOMMON" $NMAX LIBPREFIX="libopenblasp64"   $AVX $LAPACKE INTERFACE64=1

COMMON="%{optflags} -fPIC -fopenmp -pthread"
FCOMMON="$COMMON -frecursive -fdefault-integer-8"
make -C openmp64   $TARGET USE_THREAD=1 USE_OPENMP=1 FC=gfortran CC=gcc COMMON_OPT="$COMMON" FCOMMON_OPT="$FCOMMON" $NMAX LIBPREFIX="libopenblaso64"   $AVX $LAPACKE INTERFACE64=1 CPP_THREAD_SAFETY_TEST=1

COMMON="%{optflags} -fPIC"
FCOMMON="$COMMON -frecursive  -fdefault-integer-8"
make -C serial64_   $TARGET USE_THREAD=0 USE_LOCKING=1 USE_OPENMP=0 FC=gfortran CC=gcc COMMON_OPT="$COMMON" FCOMMON_OPT="$FCOMMON" $NMAX LIBPREFIX="libopenblas64_"  $AVX $LAPACKE INTERFACE64=1 SYMBOLSUFFIX=64_
make -C threaded64_ $TARGET USE_THREAD=1 USE_OPENMP=0 FC=gfortran CC=gcc COMMON_OPT="$COMMON" FCOMMON_OPT="$FCOMMON" $NMAX LIBPREFIX="libopenblasp64_" $AVX $LAPACKE INTERFACE64=1 SYMBOLSUFFIX=64_

COMMON="%{optflags} -fPIC -fopenmp -pthread"
FCOMMON="$COMMON -frecursive -fdefault-integer-8"
make -C openmp64_   $TARGET USE_THREAD=1 USE_OPENMP=1 FC=gfortran CC=gcc COMMON_OPT="$COMMON" FCOMMON_OPT="$FCOMMON" $NMAX LIBPREFIX="libopenblaso64_" $AVX $LAPACKE INTERFACE64=1 SYMBOLSUFFIX=64_ CPP_THREAD_SAFETY_TEST=1
%endif

%install
make -C serial USE_THREAD=0 PREFIX=%{buildroot} OPENBLAS_LIBRARY_DIR=%{buildroot}%{_libdir} OPENBLAS_INCLUDE_DIR=%{buildroot}%{_includedir}/%name OPENBLAS_BINARY_DIR=%{buildroot}%{_bindir} OPENBLAS_CMAKE_DIR=%{buildroot}%{_libdir}/cmake install

%if %{with system_lapack} && %{lapacke}
cp -a %{_includedir}/lapacke %{buildroot}%{_includedir}/%{name}
%endif

suffix=""
slibname=`basename %{buildroot}%{_libdir}/libopenblas${suffix}-*.so .so`
mv %{buildroot}%{_libdir}/${slibname}.a %{buildroot}%{_libdir}/lib%{name}.a
if [[ "$suffix" != "" ]]; then
   sname=$(echo $slibname | sed "s|$suffix||g")
   mv %{buildroot}%{_libdir}/${slibname}.so %{buildroot}%{_libdir}/${sname}.so
else
   sname=${slibname}
fi

olibname=`echo ${slibname} | sed "s|lib%{name}|lib%{name}o|g"`
install -D -pm 644 openmp/${olibname}.a %{buildroot}%{_libdir}/lib%{name}o.a
if [[ "$suffix" != "" ]]; then
   oname=$(echo $olibname | sed "s|$suffix||g")
else
   oname=${olibname}
fi
install -D -pm 755 openmp/${olibname}.so %{buildroot}%{_libdir}/${oname}.so

plibname=`echo ${slibname} | sed "s|lib%{name}|lib%{name}p|g"`
install -D -pm 644 threaded/${plibname}.a %{buildroot}%{_libdir}/lib%{name}p.a
if [[ "$suffix" != "" ]]; then
   pname=$(echo $plibname | sed "s|$suffix||g")
else
   pname=${plibname}
fi
install -D -pm 755 threaded/${plibname}.so %{buildroot}%{_libdir}/${pname}.so

%if %build64
slibname64=`echo ${slibname} | sed "s|lib%{name}|lib%{name}64|g"`
install -D -pm 644 serial64/${slibname64}.a %{buildroot}%{_libdir}/lib%{name}64.a
slibname64_=`echo ${slibname} | sed "s|lib%{name}|lib%{name}64_|g"`
install -D -pm 644 serial64_/${slibname64_}.a %{buildroot}%{_libdir}/lib%{name}64_.a

if [[ "$suffix" != "" ]]; then
   sname64=$(echo ${slibname64} | sed "s|$suffix||g")
   sname64_=$(echo ${slibname64_} | sed "s|$suffix||g")
else
   sname64=${slibname64}
   sname64_=${slibname64_}
fi
install -D -pm 755 serial64/${slibname64}.so %{buildroot}%{_libdir}/${sname64}.so
install -D -pm 755 serial64_/${slibname64_}.so %{buildroot}%{_libdir}/${sname64_}.so

olibname64=`echo ${slibname} | sed "s|lib%{name}|lib%{name}o64|g"`
install -D -pm 644 openmp64/${olibname64}.a %{buildroot}%{_libdir}/lib%{name}o64.a
olibname64_=`echo ${slibname} | sed "s|lib%{name}|lib%{name}o64_|g"`
install -D -pm 644 openmp64_/${olibname64_}.a %{buildroot}%{_libdir}/lib%{name}o64_.a

if [[ "$suffix" != "" ]]; then
   oname64=$(echo ${olibname64} | sed "s|$suffix||g")
   oname64_=$(echo ${olibname64_} | sed "s|$suffix||g")
else
   oname64=${olibname64}
   oname64_=${olibname64_}
fi
install -D -pm 755 openmp64/${olibname64}.so %{buildroot}%{_libdir}/${oname64}.so
install -D -pm 755 openmp64_/${olibname64_}.so %{buildroot}%{_libdir}/${oname64_}.so

plibname64=`echo ${slibname} | sed "s|lib%{name}|lib%{name}p64|g"`
install -D -pm 644 threaded64/${plibname64}.a %{buildroot}%{_libdir}/lib%{name}p64.a
plibname64_=`echo ${slibname} | sed "s|lib%{name}|lib%{name}p64_|g"`
install -D -pm 644 threaded64_/${plibname64_}.a %{buildroot}%{_libdir}/lib%{name}p64_.a

if [[ "$suffix" != "" ]]; then
   pname64=$(echo $plibname64 | sed "s|$suffix||g")
   pname64_=$(echo $plibname64_ | sed "s|$suffix||g")
else
   pname64=${plibname64}
   pname64_=${plibname64_}
fi
install -D -pm 755 threaded64/${plibname64}.so %{buildroot}%{_libdir}/${pname64}.so
install -D -pm 755 threaded64_/${plibname64_}.so %{buildroot}%{_libdir}/${pname64_}.so
%endif

pushd %{buildroot}%{_libdir}
ln -sf ${sname}.so lib%{name}.so.0
ln -sf ${sname}.so lib%{name}.so
ln -sf ${oname}.so lib%{name}o.so.0
ln -sf ${oname}.so lib%{name}o.so
ln -sf ${pname}.so lib%{name}p.so.0
ln -sf ${pname}.so lib%{name}p.so

%if %build64
ln -sf ${sname64}.so lib%{name}64.so.0
ln -sf ${sname64}.so lib%{name}64.so
ln -sf ${sname64_}.so lib%{name}64_.so.0
ln -sf ${sname64_}.so lib%{name}64_.so
ln -sf ${oname64}.so lib%{name}o64.so.0
ln -sf ${oname64}.so lib%{name}o64.so
ln -sf ${oname64_}.so lib%{name}o64_.so.0
ln -sf ${oname64_}.so lib%{name}o64_.so
ln -sf ${pname64}.so lib%{name}p64.so.0
ln -sf ${pname64}.so lib%{name}p64.so
ln -sf ${pname64_}.so lib%{name}p64_.so.0
ln -sf ${pname64_}.so lib%{name}p64_.so
%endif

%if %{execstack}
for lib in %{buildroot}%{_libdir}/libopenblas*.so; do
 execstack -c $lib
done
%endif

rm -rf %{buildroot}%{_libdir}/cmake
rm -rf %{buildroot}%{_libdir}/pkgconfig

%files
%license serial/LICENSE
%doc serial/Changelog.txt serial/GotoBLAS* 

%files serial
%{_libdir}/lib%{name}.so.*
%{_libdir}/lib%{name}-*.so

%files openmp
%{_libdir}/lib%{name}o.so.*
%{_libdir}/lib%{name}o-*.so

%files threads
%{_libdir}/lib%{name}p.so.*
%{_libdir}/lib%{name}p-*.so

%if %build64
%files serial64
%{_libdir}/lib%{name}64.so.*
%{_libdir}/lib%{name}64-*.so

%files openmp64
%{_libdir}/lib%{name}o64.so.*
%{_libdir}/lib%{name}o64-*.so

%files threads64
%{_libdir}/lib%{name}p64.so.*
%{_libdir}/lib%{name}p64-*.so

%files serial64_
%{_libdir}/lib%{name}64_.so.*
%{_libdir}/lib%{name}64_-*.so

%files openmp64_
%{_libdir}/lib%{name}o64_.so.*
%{_libdir}/lib%{name}o64_-*.so

%files threads64_
%{_libdir}/lib%{name}p64_.so.*
%{_libdir}/lib%{name}p64_-*.so
%endif

%files devel
%{_includedir}/%{name}/
%{_libdir}/lib%{name}.so
%{_libdir}/lib%{name}p.so
%{_libdir}/lib%{name}o.so
%if %build64
%{_libdir}/lib%{name}p64_.so
%{_libdir}/lib%{name}o64.so
%{_libdir}/lib%{name}p64.so
%{_libdir}/lib%{name}64_.so
%{_libdir}/lib%{name}o64_.so
%{_libdir}/lib%{name}64.so
%endif

%files static
%{_libdir}/lib%{name}.a
%{_libdir}/lib%{name}o.a
%{_libdir}/lib%{name}p.a
%if %build64
%{_libdir}/lib%{name}o64.a
%{_libdir}/lib%{name}p64.a
%{_libdir}/lib%{name}o64_.a
%{_libdir}/lib%{name}p64_.a
%{_libdir}/lib%{name}64.a
%{_libdir}/lib%{name}64_.a
%endif

%changelog
* Sun Feb 04 2024 Funda Wang <fundawang@yeah.net> - 0.3.26-1
- New version 0.3.26

* Wed Nov 8 2023 XiWei Gu <guxiwei-hf@loongson.cn> - 0.3.23-3
- Enable DYNAMIC_ARCH for LoongArch64

* Tue Oct 31 2023 XiWei Gu <guxiwei-hf@loongson.cn> - 0.3.23-2
- Add opt for LoongArch64

* Sun Apr 16 2023 Funda Wang <fundawang@yeah.net> - 0.3.23-1
- New version 0.3.23

* Sat Apr 15 2023 Heng Qi <hengqi@linux.alibaba.com> - 0.3.21-2
- Refactor the spec file

* Fri Jan 27 2023 Funda Wang <fundawang@yeah.net> - 0.3.21-1
- Import package for anolis 23
